var parser = require("cirru-parser"),
    generator = require("@babel/generator"),
    operations = require("./operations"),
    req = new XMLHttpRequest(),
    source = document.querySelector("#source"),
    compiled = document.querySelector("#compiled");

require("./layout.css");

req.open("GET", "./test/cirru/cond.cirru");

req.onload = function (res) {
  var code = req.responseText;
  source.value = code;
  return tryRender(code);
};

req.send();

var render = function (code) {
  var ast = parser.pare(code),
      result = operations.transform(ast),
      display = JSON.stringify(result, null, 2);
  console.log("ast:", ast);
  compiled.value = display;
  console.log("result:", display);
  console.log("generated code:");
  return console.log(generator.default(result, {}, code).code);
};

var tryRender = function (code) {
  try {
    render(code);
  } catch (err) {
    var message = err.message,
        stack = err.stack;
    compiled.value = message + "\n\n" + stack;
  }

  return undefined;
};

source.addEventListener("input", function (event) {
  return tryRender(event.target.value);
});